﻿
using Microsoft.Ajax.Utilities;
using System;
using System.Drawing;
using System.Linq;
using Wisej.Web;

namespace WisejWebApplication1
{
    public partial class Window1 : Form
    {
        public Window1()
        {
            InitializeComponent();
        }

        private void dataGridView1_Appear(object sender, EventArgs e)
        {
            for (int i = 0; i < 8; i++)
            {
                var dataGridViewColumn = CreateDataGridViewColumn(i);
                dataGridView1.Columns.Add(dataGridViewColumn);                
            }

            dataGridView1.Rows.Add();
            dataGridView1.Rows.Add();
            dataGridView1.Rows.Add();
            dataGridView1.Rows.Add();
            dataGridView1.Rows.Add();

            for (int i = 0; i < 8; i++)
            {
                dataGridView1.Rows.ForEach(row =>
                {
                    var userControl = new UserControl();
                    userControl.Name = $"UserControl_{row.Index}_{i}";
                    row[i].Control = userControl;
                });
            }
        }

        private DataGridViewColumn CreateDataGridViewColumn(int count)
        {
            DataGridViewColumn expressDataColumn = new DataGridViewColumn();
            expressDataColumn.HeaderText = $"Header_{count}";
            expressDataColumn.Name = $"TestColumn_{count}";
            expressDataColumn.HeaderCell = CreateHeaderCell(count);

            return expressDataColumn;
        }

        private DataGridViewColumnHeaderCell CreateHeaderCell(int count)
        {
            var headerCell = new DataGridViewColumnHeaderCell()
            {
                Control = CreateDeleteExpressButton(count),
                Value = $"TestHeader_{count}"
            };

            return headerCell;
        }

        private Button CreateDeleteExpressButton(int count)
        {
            var deleteExpress = new Button();
            deleteExpress.Dock = DockStyle.Right;
            deleteExpress.ImageSource = "tab-close";
            deleteExpress.Name = $"DeleteColumn_{count}";
            deleteExpress.Size = new Size(40, 23);
            deleteExpress.TabIndex = 15;
            deleteExpress.BackColor = Color.Red;
            deleteExpress.Click += new EventHandler(DeleteExpress);

            return deleteExpress;
        }

        private void DeleteExpress(object sender, EventArgs e)
        {

            var headerDeleteButton = sender as Button;
            DataGridViewColumn dataGridViewColumn = dataGridView1.Columns
                .Where(x => x.HeaderCell?.Control?.Name == headerDeleteButton.Name)
                .SingleOrDefault();

            if (dataGridViewColumn != null)
            {
                dataGridView1.Columns.RemoveAt(dataGridViewColumn.Index);
            }
        }
    }
}
